"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var jsonschema_1 = require("jsonschema");
function validator(schemaPath, schemaName) {
    var schema = JSON.parse(fs.readFileSync(schemaPath).toString());
    var validator = new jsonschema_1.Validator();
    validator.addSchema(schema);
    return function (interfaceName, obj) {
        if (!(interfaceName in schema.definitions)) {
            throw new Error("Interface does not exist: " + interfaceName);
        }
        var v = validator.validate(obj, schema.definitions[interfaceName]);
        if (v.valid) {
            return obj;
        }
        throw new Error(v.toString());
    };
}
exports.validator = validator;
